#include "Entity.h"

#include <iostream>
#include <glm\glm.hpp>
#include <glm\gtc\matrix_transform.hpp>
#include <glm\gtc\type_ptr.hpp>

using namespace babyOnWheels;
using namespace scene;
using namespace entities;

Entity::Entity(SceneObject* _model, Shader* _shader)
	:model(_model),
	shader(_shader)
{
}


Entity::~Entity()
{
}

void Entity::update(float time_delta) {

}

void Entity::draw(GLuint handle) {
	auto& obj = model->modelMatrix;
	auto model_location = glGetUniformLocation(shader->programHandle, "model");
	glUniformMatrix4fv(model_location, 1, GL_FALSE, glm::value_ptr(obj));

	model->draw(handle);
}

SceneObject* Entity::getModel() {
	return model;
}
