#pragma once


#include "../Scene/Cube.h"
#include "../Shader.h"
#include "Entity.h"


namespace babyOnWheels {
	namespace entities {
		using namespace scene;

		class Player : public Entity
		{
		public:
			Player(SceneObject* _model, Shader* _shader);
			virtual ~Player();

			virtual void update(float time_delta);
			
			virtual void doBrake(bool value);
			virtual void doAccelerate(bool value);
			virtual void doSteer(float value);
			virtual void jump();
			float getSpeed() { return speed; };

			int points = 0;
			bool dead = false;
		private:
			int health;
			
			float speed = 0;
			float maxSpeed = 12;
			float minSpeed = 8;
			float breakStrength = 10.0f;
			float accelerateStrength = 5.0f;
			float handling = 12;

			bool accelerate = false;
			bool brake = false;
			float steer = 0;
		};
	}
}