#pragma once

#include <string>
#include <fstream>
#include <sstream>
#include <iostream>
#include <vector>
using namespace std;
// GL Includes
#include "../../External/Include/GL/glew.h"
#include "../../External/Include/glfw/glfw3.h"
#include "../../External/Include/glm/glm.hpp"

#include "Shader.h"

#include <assimp/scene.h>

// http ://learnopengl.com/#!Model-Loading/Mesh (28.05.2016)

struct Vertex{
	glm::vec3 Position;
	glm::vec2 Normal;
	glm::vec2 TexCoords;
};

struct Texture{
	GLuint id;
	string type;
};

class Mesh
{
public:
	/*  Mesh Data  */
	vector<Vertex> vertices;
	vector<GLuint> indices;
	vector<Texture> textures;
	/*  Functions  */
	Mesh(vector<Vertex> vertices, vector<GLuint> indices, vector<Texture> textures);
	void draw(babyOnWheels::Shader shader);
	
	~Mesh();
private:
	/*  Render data  */
	GLuint VAO; 
	GLuint VBO; 
	GLuint EBO;
	/*  Functions    */
	void setupMesh();
};

