#pragma once

// http://ogldev.atspace.co.uk/www/tutorial28/tutorial28.html
// https://github.com/triplepointfive/ogldev/blob/master/tutorial28/particle_system.cpp

#include <GL\glew.h>
#include <GLFW\glfw3.h>
#include <glm\glm.hpp>
#include <glm\gtc\matrix_transform.hpp>
#include <glm\gtc\type_ptr.hpp>
#include <iostream>
#include <vector>
#include "Texture.h"
#include "Shader.h"
#include <sstream>
#include <fstream>
#include "Random_Texture.h"

class ParticleSystem
{
public:
	ParticleSystem();
	~ParticleSystem();

	bool InitParticleSystem(glm::mat4* pos);

	void Render(float DeltaTimeMillis, const glm::mat4 VP, const glm::vec3 CameraPos);

	GLuint LoadProgram(const std::string& vs, const std::string& gs, const std::string& fs);
	GLuint LoadProgram(const std::string& vs, const std::string& gs);

private:

	void UpdateParticles(float DeltaTimeMillis);
	void RenderParticles(const glm::mat4 VP, const glm::vec3 CameraPos);

	bool m_isFirst;
	unsigned int m_currVB;
	unsigned int m_currTFB;
	GLuint m_particleBuffer[2];
	GLuint m_transformFeedback[2];
	GLuint m_updateTechnique;
	GLuint m_billboardTechnique;
	Random_Texture m_randomTexture;
	babyOnWheels::Texture* m_pTexture;
	float m_time;

	GLuint m_deltaTimeMillisLocation;
	GLuint m_randomTextureLocation;
	GLuint m_timeLocation;
	GLuint m_launcherLifetimeLocation;
	GLuint m_shellLifetimeLocation;
	GLuint m_secondaryShellLifetimeLocation;
	GLuint m_positionLauncherLocation;

	GLuint m_VPLocation;
	GLuint m_cameraPosLocation;
	GLuint m_colorMapLocation;

	glm::mat4* carriageMatrix;


};

