#include "Random_Texture.h"
#include <cstdlib>
#include <ctime>

#define GLCheckError() (glGetError() == GL_NO_ERROR)
#define RAND_MAX 100.0f


Random_Texture::Random_Texture()
{
	m_textureObj = 0;
}


Random_Texture::~Random_Texture()
{
	if (m_textureObj != 0) {
		glDeleteTextures(1, &m_textureObj);
	}
}

bool Random_Texture::InitRandomTexture(unsigned int Size)
{
	glm::vec3* pRandomData = new glm::vec3[Size];
	for (unsigned int i = 0; i < Size; i++) {
		pRandomData[i].x = RandomFloat();
		pRandomData[i].y = RandomFloat();
		pRandomData[i].z = RandomFloat();
	}

	glGenTextures(1, &m_textureObj);
	glBindTexture(GL_TEXTURE_1D, m_textureObj);
	glTexImage1D(GL_TEXTURE_1D, 0, GL_RGB, Size, 0.0f, GL_RGB, GL_FLOAT, pRandomData);
	glTexParameterf(GL_TEXTURE_1D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_1D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_1D, GL_TEXTURE_WRAP_S, GL_REPEAT);

	delete[] pRandomData;

	return GLCheckError();
}


void Random_Texture::Bind(GLenum TextureUnit)
{
	glActiveTexture(TextureUnit);
	glBindTexture(GL_TEXTURE_1D, m_textureObj);
}

float Random_Texture::RandomFloat()
{
	srand((unsigned int)time(NULL));

	float a = 5.0;

	return (float)rand() / (float)(RAND_MAX) * a;

}
