#pragma once

#include <GL\glew.h>
#include "SceneObject.h"
#include "../Shader.h"

#define CUBE_VERTEX_COUNT 24
#define CUBE_INDEX_COUNT 36

namespace babyOnWheels {
	namespace scene {
		class Cube : public SceneObject
		{
		public:
			Cube(glm::mat4& matrix, Shader* _shader);
			virtual ~Cube();

			virtual void update(float time_delta);
			virtual void draw(GLuint handle);

		private:
			GLuint vao;
			GLuint positionBuffer, normalBuffer, uvBuffer, indexBuffer;
			Shader* shader;

			static const float positions[CUBE_VERTEX_COUNT * 3];
			static const float normals[CUBE_VERTEX_COUNT * 3];
			static const float uvs[CUBE_VERTEX_COUNT * 2];
			static const unsigned int indices[CUBE_INDEX_COUNT];
			
		};
	}
}

