#include "Light.h"

using namespace babyOnWheels;
using namespace scene;

/*
_col = Farbe des Lichtes
_rot = Rotation des Lichtes
_ambient = intensitt der nicht beleuchteten stellen
*/
Light::Light(glm::vec3& _col, glm::vec3& _rot, glm::vec3& _ambient)
	:color(_col),
	rotation(_rot),
	ambientIntensity(_ambient)
{
}

/*
handle = shader handle

bindet alle ntigen variablen zu dem angegebenen Shader
*/
void Light::bind(GLuint handle) {
	auto sunColor = glGetUniformLocation(handle, "sunLight.color");
	glUniform3f(sunColor, color.x, color.y, color.z);
	auto ambient = glGetUniformLocation(handle, "sunLight.ambientIntenstity");
	glUniform3f(ambient, ambientIntensity.x, ambientIntensity.y, ambientIntensity.z);
}

glm::vec3 Light::getRotation() {
	return rotation;
}

Light::~Light()
{
}
