#pragma once
#include "SceneObject.h"
#include <vector>
#include <GL/glew.h>
#include <map>
#include <string>
#include <iostream>
#include <sstream>
#include "../PhysxManager.h"

using namespace std;

namespace babyOnWheels {

	namespace scene {
		class SceneModel :
			public SceneObject
		{
		public:
			SceneModel(glm::mat4& matrix);
			SceneModel(SceneModel* _model, PhysxManager* physxManager);
			~SceneModel();

			void loadSceneModel(const char* path, GLuint _texture_handle);

			virtual void update(float time_delta);
			virtual void draw(GLuint handle);
			void translate(glm::vec3 _value);
			void rotate(float angle, glm::vec3 _axis);
			bool checkIfInside(glm::mat4& _other);

			glm::vec4 getSphere();

			std::map<string, SceneModel*> sceneModels_Map;
		private:
			std::vector<unsigned short> indices; 
			GLuint texture_handle;
			GLuint vertexbuffer;
			GLuint uvbuffer;
			GLuint normalbuffer;
			GLuint elementbuffer;

			std::vector<glm::vec3> indexed_vertices;
			glm::mat4 model_mat;
		};
	}
}

