#pragma once
#define SCENE_OBJECT

#include <glm\glm.hpp>
#include "Physx/PxPhysicsAPI.h"
#include "GL\glew.h"
#include "../PhysxManager.h"

using namespace physx;


namespace babyOnWheels {
	namespace scene {
		class SceneObject
		{
		public:
			SceneObject(glm::mat4& _modelMatrix);
			virtual ~SceneObject();
			// virtual SceneObject changedSceneObject();

			virtual void update(float time_delta) = 0;
			virtual void draw(GLuint handle) = 0;
			glm::mat4 modelMatrix;

			
			virtual void attachRigidBody(Rigidbody* _body);
			virtual void attachCollider(ColliderStatic* _collider);
			Rigidbody* body = nullptr;
			ColliderStatic* collider = nullptr;
			glm::mat4 trigger = glm::mat4(1);
		};
	}
}
