#version 330 core

in vec2 UV;
//in vec3 viewRay;

out vec4 color;

uniform mat4 prevMVP;
uniform mat4 invMV;
uniform sampler2D renderedTexture;
uniform sampler2D brightTexture;
uniform sampler2D depthTexture;
uniform float currentFps;

void main(){
	float mblurScale = currentFps / 60;

	float depthValue = texture(depthTexture, UV).r;
	vec4 current = vec4(UV.x * 2 - 1, (1-UV.y)*2-1, depthValue, 1);
	vec4 worldpos = invMV*current;
	worldpos = worldpos / worldpos.w; 

	vec4 prev = prevMVP * worldpos;
	prev.xyz /= prev.w;

	vec2 blurVec = (current - prev).xy / 3 * mblurScale;//prev.xy - UV;

	vec4 result = texture(renderedTexture, UV) ;
	result += texture(brightTexture, UV) ;

	int samples=20;

	for(int i=1 ; i<samples; i++) {
		vec2 offset = blurVec * (float (i)/float(samples - 1) -0.5);

		result += texture(renderedTexture, UV + offset);
		result += texture(brightTexture, UV + offset) ;
	}

	color = result / float(samples);
}
