#version 330 core

uniform vec4 Color;
uniform vec2 InverseSize;
in float gAlpha;
in vec2 gTexCoord;
out vec4 FragColor;
uniform sampler2D SpriteSampler;
uniform sampler2D DepthSampler;

void main()
{
    vec2 tc = gl_FragCoord.xy * InverseSize;
    float depth = texture(DepthSampler, tc).r;
    if (depth < gl_FragCoord.z)
        discard;

    float d = depth - gl_FragCoord.z;
    float softness = 1.0 - min(1.0, 40.0 * d);
    softness *= softness;
    softness = 1.0 - softness * softness;

    float falloff = texture(SpriteSampler, gTexCoord).r;
    float A = gAlpha * falloff * falloff;
    FragColor = Color * vec4(1, 1, 1, A * softness);
}