#version 330 core

in vec4 Position;
in vec3 Velocity;
in float BirthTime;
uniform mat4 ModelviewProjection;
uniform float Time;
out float vAlpha;
out float vBirthTime;
out vec3 vVelocity;
out vec3 vPosition;
uniform float FadeRate;

void main()
{
    gl_Position = ModelviewProjection * Position;
    vBirthTime = BirthTime;
    vAlpha = max(0.0, 1.0 - (Time - BirthTime) * FadeRate);
    vVelocity = normalize(Velocity);
    vPosition = Position.xyz;
}
