#version 330 core

// Ouput data
layout(location = 0) out vec4 fragColor;

in vec3 worldNormal;
in vec2 texCoord;

uniform sampler2D color_texture;

struct directionalLight 
{ 
   vec3 color; 
   vec3 dir; 
   float ambientIntenstity; 
};

struct Material 
{ 
   float specPower; 
   float specShininess;
   vec3 specColor; 
};

uniform directionalLight sunLight;
uniform Material mat;
uniform vec3 viewPos;

void main()
{
	vec4 diffColor = vec4(texture(color_texture, texCoord).xyz, 1.0);

	float diffuseIntensity = max(0.0, dot(normalize(worldNormal), -sunLight.dir)); 
	vec4 baseColor = diffColor * vec4(sunLight.color*(sunLight.ambientIntenstity+diffuseIntensity), 1.0f); 

	vec3 viewDir = normalize(viewPos);
	vec3 halfDir = normalize(sunLight.dir + viewDir);
    float specAngle = max(dot(halfDir, viewDir), 0.0);

    float specular = pow(specAngle, mat.specShininess);

	vec4 specColor = vec4(mat.specColor, 1.0); 

	fragColor = baseColor;// +  specColor * specular;
}