#version 330 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec2 uv;
layout(location = 2) in vec3 normal;

out vec2 UV_coord;
out vec3 Position_worldspace;
out vec3 Normal_cameraspace;
out vec3 EyeDirection_cameraspace;
out vec3 LightDirection_cameraspace;
out vec4 ShadowCoord;

uniform mat4 VP;
uniform mat4 V;
uniform mat4 M;
uniform vec3 LightInvDirection_worldspace;
uniform mat4 DepthBiasVP;


void main(){
	gl_Position =  VP * M * vec4(position,1);
	ShadowCoord = DepthBiasVP * M * vec4(position,1);
	Position_worldspace = (M * vec4(position,1)).xyz;
	EyeDirection_cameraspace = vec3(0,0,0) - ( V * M * vec4(position,1)).xyz;
	LightDirection_cameraspace = (V*vec4(LightInvDirection_worldspace,0)).xyz;
	Normal_cameraspace = ( V * M * vec4(normal,0)).xyz;

	UV_coord = uv;
}

